{ ========================================================================= }
{                                                                           }
{                                  DRAW.PAS                                 }
{                                                                           }
{              Constants used by CALENDAR.PAS to draw a calendar            }
{                                                                           }
{ ========================================================================= }

unit Draw;

interface

const
  figure: array[1..95] of string[85] = (

'*******************************************************************************',
'*******************************************************************************',
'*******************************************************************************',
'*MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM*',
'*MMMMM**MMMMMMMMMMMMMMMMMMMMMHHHHHCCCCCHHHHMMMMMMMMMMMMMMMMMMMMMMMMMMMMM**MMMM*',
'*MMMMM**MMMMMMMMMMMMMMMMMMMHC***************CCMMMMMMMMMMMMMMMMMMMMMMMMMM**MMMM*',
'*MM********MMMMM4MMMMMMMMMH.....           ....CCCHHM4MMMMMMMMMMMMMMM********M*',
'*MM********MMMMMMMMMMHHHH....HCC....           .....CMMMMMMMMMMMMMMMM********M*',
'*MMMMM**MMMMMMMMMMMMMHHH...CHHHHCCCC..             ...HMMMMMMMMMMMMMMMMM**MMMM*',
'*MMMMM**MMMMMMMMMMMHH....HCCCC..CCCHH...              ....CMMMMMMMMMMMMM**MMMM*',
'*MMMMM**MMMMMMMMMMH.....CCC...CCH....HH...             .....HMMMMMMMMMMM**MMMM*',
'*MMMMM**MMMMMMMHHH....CCC..CHHC.....HH....               .....HMMMMMMMMM**MMMM*',
'*MMMMM**MMMMMMMH.....CHHCCHHHCMMMMH.HHHCCHH...             ....HMMMMMMMM**MMMM*',
'*MMMMMMMMMMMMMH.....HHHH.CCHCHMMMC..CHH.CCCH..             ....CMMMMMMMMMMMMMM*',
'*MMMMMMMMMMMMMH...HCCCCCC ..CC  C.....CCCMMCC.          ........MMMMMMMMMMMMMM*',
'*MMMMMMMMMMMH...HHHCCCC .. ..CHMMM. .. MMMMHM..         .......CMMMMMMMMMMMMMM*',
'*MMMMMMMMMMMH.HHHH..   C  .CCHMC. ......HHHMMMH...      .....  .CMMMMMMMMMMMMM*',
'*MMMMMMMMMMH..CHHHH  CCHCCCHHMMCCMMMCCHHHHHHHMM....     ...     ..MMMMMMMMMMMM*',
'*MMMMMMMMMMH..HCCHHCHCCHCHHHMMHCMMMHHHHC.....MMHT..    .         .MMMMMMMMMMMM*',
'*MMMMMMMMMH.. CCH.. HHCMMMHHMMHCCCCHCCCC       .MMMH.             ..MMMMMMMMMM*',
'*MMMMMMMMMH.. .HH..CCC. .CCCC..... ..MMC.      ..MMC..CMMMM      .CMMMMMMMMMMM*',
'*MMMMMMMMMH.  .HMH....                           .MMC..         ...HMMMMMMMMMM*',
'*MMMMMMMMMM.  .HMH....                           ..HHC..         ..CMMMMMMMMMM*',
'*MMMMMMMMMM. ..HMH....                            .MMMC..       ...CMMMMMMMMMM*',
'*MMMMMMMHH. ...HMC...                             MMMC...      .....CHMMMMMMMM*',
'*MMMMMMMHHH ...HHC...                              ..MMMC..C    ..  .CMMMMMMMM*',
'*MMMMMMMHH.. CMH....                                .MMMC..    ... .. MMMMMMMM*',
'*MMMMMMMH...  .MM.....                   .            .CMMM..    .C.  MMMMMMMM*',
'*MMMMMMHH....  .MM.....                 ...LHHH....     CMMC..     ..  MMMMMMM*',
'*MMMMMMH...   .MM......              ..HHHTT            CMH C.      C. MMMMMMM*',
'*MMMMMMH...   .MMC.CCHHH..          .......HLL...        C H ..     ..  . MMMM*',
'*MMMMMM....   CMMH....LHHHHHH.        ...H***.T.         .H  C     ..C   MMMMM*',
'*MMMMMM....   HMMH...HT.M***H...     ..HL.LT.            .  .H.     ...    MMM*',
'*MMMMMC....  .HMMH... T.T.TC.HC..                            KCH       .    MM*',
'*MMMMM..... ..CMMMC. .        ..                           .HMC.  .   .     MM*',
'*MMMMM.....  .HCHHH..       ...                         .CMHHH.   .          M*',
'*MMMM.......  .CMMH....      ...                          HMMHC.    . .      M*',
'*MMM.........   .MMH....     ...                         .CHHHCC.    .       M*',
'*MMM.. .....     .HHC...     ...       .                 .HHHHCC..    . .   MM*',
'*MMM.. .......    .HH.....  .....    . .                ..HMMMHCC..          M*',
'*MMM..........C.    ..HV..........T.                    .HMMMMHHCC.          M*',
'*MMM..........C.    H.HV..........T.                    .HMMMMHHCC.          M*',
'*MMMM.........CCC   ..CH.......   ........O           ..CHMMMMMHCC.         MM*',
'*MMMM.........CCC   ..CMH.....THHHHL....             .....MMMMMMCC..        MM*',
'*MMMM.......CCCCC  ....HMMHC.....CHC.....             .....HMMMMHC..        MM*',
'*MMMMM....    ..CH..CCHHMMHHH......              ..         .CCCCCC..    .MMMM*',
'*MMMMM...     ..HHC.CCHHHHHMMMM.....         .....         ..CCCCCCC..  .CCMMM*',
'*MMMMM..     ...HHCCC..CHHHMMMMC.............CC .         ..CCCCCCC.....CMMMMM*',
'*MMMMM..     ..CHHH.. ..........CHC.....CCCCCC.           ..CCCCCC... .CCMMMMM*',
'*MMMMM.    ..CCCHC........C.........HHHHHHCCC..           .CCCCCC...  ..CMMMMM*',
'*MMMC.    ..CCHC.  H.. ....H..  .C....CHHHCC...          ...CCCCCC.. .....MMMM*',
'*MMMH.  ....CH.. . .   ...CH.. ....C.  CHCC..            ...CCCCCCC.  ..CMMMMM*',
'*MHC.  ....H........C...  .HCH ..H... ...CC..           .CCCHCCCCCCC...CCMMMMM*',
'*HC   ....C ...CHCCCHHC...H.......C...  ..C..          .CCHCCCHCCCCCC. CCMMMMM*',
'*.   ....HH...CHHCCMHC.....     ....   ..C..         .CCHCCHCCCHCCCCCC.CCMMMMM*',
'*   ....HH..CCCCCHC.......                C...       .HCCHCCHCHCCCCCCCCCCMMMMM*',
'*  ....HHH..CCCCCHC.......                .CC..    HHHHHHCHHCCHCCHCCCCCCCMMMMM*',
'*.....CHHH....MCCCCC.......               .HHHC.   HHHHHHCHCCHCCHCCHCCCCCMMMMM*',
'*....CCHHH....HCHH........                .HHHHHM.CHHHHHHHHHHCHCHCCHCCCCCMMMMM*',
'*...CCCHHHHT  HMHM.........               CHHHHHM. MHHHHHHHHHHCHCCHCCCCCCMMMMM*',
'*..CCCCHHH. HCC CH.........CLCH..      .HHCHHHHHH.MHHHHHHHHHHHHHCCCCCCCCCMMMMM*',
'*CCCCCHHHHCHC.HC...........HHH.....MMM.HMHHHHH  KMHHHHHHHHHHHHHHHHCCCCCCCMMMMM*',
'*CCCCCCHHHH H..............HM$HH..  ..***H8HHHHHHMHHHHHHHHHHHHHHHHHCCCCCCMMMMM*',
'*CCCCCHHHHH.   .H.......   ..    .        HHHHHHH...HHHHHHHHHHHHHHHCCCCCCMMMMM*',
'*CCCCCHHHHHH.    ........        .        HHHHHHC...CHHHHHHHHHCHCHCHCHCCCMMMMM*',
'*CCCCCHHHHHHH.............     ....      .HHHHHH.....CHHHHHHHHHHHCHCCCCCCMMMMM*',
'*CCCHCHHHHHHHHHHHC.........    ...H...   .8HHHH......CHHHHHHHHHHHHCHCCCCCMMMMM*',
'*CCCHCHHHHHHHHHCHC.........    ..       .HHHHH.........HHHHHHHHHHHHHHHHCCMMMMM*',
'*CCHCHHHHHH......CCC........   MMMMMM. .HH8HHC.......*.HHHHHHHHHHHHHHHHCCMMMMM*',
'*CCCCCCHCC.........CC............LLC  .HHHHHH..C... .HC ..HHHHHHHHHHHHHCCMMMMM*',
'*CCCCCHHHCCC...CCCCCCC....CCCCCCCCC...HHHH8HC... .........HHHHHHHHHHHHHHHHMMMM*',
'*CCCCCCC CHHHM      .CCC.......   ..HHHHHC.C ..* .........HHHHHHHHHHHHHHHHMMMM*',
'*CCCCC..999.....=         .CCCC..HHHHHHHHHHC..      C   ...HHHHHHHHHHHHHHHMMMM*',
'*CCC..........            .CCCCHHHHHHHHHCCCC..       C.   CCCHHHHHHHHHHHHHMMMM*',
'*CCC...........            ...CHHHHHHHHCCCCC..         C DCCCCHHHHHHHHHHHHMMMM*',
'*CC...............          ....C HHHHCCCC.C....      .RC....CCHHHHHHHHHHHMMMM*',
'*.......CCCCCCCCCC..          ...CHHHCCC*C.C....      . RC....CCHHHHHHHHHHMMMM*',
'*C........CCCCCCCC               .CHCCC.         .....HC.........CHHHHHHHHMMMM*',
'*C.........CCCCC.      .......  ....     .       ..CHCC...........CHHHHHHHMMMM*',
'*C........CCCCCC     .C..  .   ..        .      .CECC.............CHHHHHHHMMMM*',
'*C......C.CCCCCC  ..CCC.     ..           .      CCCC...............HHHHHHMMMM*',
'*C.....CCCCCHCC.=.CCC    .....     .. ..  ..... HCCC................CHHHHHMMMM*',
'*C......CCHCHHCCCCCHC ....CC      ... ..  ....HCCLCLL.................HHHHMMMM*',
'*C......CCCCHHHCCCC.....CCC.   .   ......  C..HHCCCCCC.................HHHMMMM*',
'*C......CCCCHHHCCCC.....CCC.   .   ......  C..HHCCCCCC.................HHHMMMM*',
'*C.........CCCCCCHHHHCCCCHCCCCC...CC...CCCHHHCC......T.................HCHMMMM*',
'*C.......CCCCCCCCHCCHHCCCCHCCCCCCCCCCCHHHC3...                        ...HMMMM*',
'*C.........CCCCCCC.HHHHHHCCCCCCCCHHHHHHHHH.                             .HMMMM*',
'*C......C...CCCCCCCCCCCHHHHHHHHHHHHHCCCCCCC.                          .C''''MMMM*',
'*.           .CCCCCCHCCCCCCCCCHHHCCCCCCC.                             .H''''''M4M*',
'*.              ..CCCCCCCCCCCCHCCCCCCC.                            .HHHHH''''MMM*',
'*MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM*',
'*******************************************************************************',
'*******************************************************************************',
'*******************************************************************************'

);



  messages: array[1..6] of string[85] = (

 '*******************************************************************************',
 '**                        *                         *                        **',
 '*                         *                         *                         *',
 '*   S  M  T  W  T  F  S   *   S  M  T  W  T  F  S   *   S  M  T  W  T  F  S   *',
 '*********************************** DEP. MATHEMATICS/UFPB/JO~'#8'AO PESSOA/BRAZIL **',
 '**                                                                           **'

 );



   months: array[1..4] of string[85] = (

 '*      J A N U A R Y      *     F E B R U A R Y     *        M A R C H        *',
 '*        A P R I L        *          M A Y          *         J U N E         *',
 '*         J U L Y         *       A U G U S T       *    S E P T E M B E R    *',
 '*      O C T O B E R      *     N O V E M B E R     *     D E C E M B E R     *'

 );



var
  number: array[0..9, 1..14] of string[10];


implementation

begin

  number[0, 1]  := ' 0000000  ';     number[1, 1]  := '    111   ';
  number[0, 2]  := '000000000 ';     number[1, 2]  := '   1111   ';
  number[0, 3]  := '000   000 ';     number[1, 3]  := '  11111   ';
  number[0, 4]  := '000   000 ';     number[1, 4]  := ' 111111   ';
  number[0, 5]  := '000   000 ';     number[1, 5]  := '111 111   ';
  number[0, 6]  := '000   000 ';     number[1, 6]  := '    111   ';
  number[0, 7]  := '000   000 ';     number[1, 7]  := '    111   ';
  number[0, 8]  := '000   000 ';     number[1, 8]  := '    111   ';
  number[0, 9]  := '000   000 ';     number[1, 9]  := '    111   ';
  number[0, 10] := '000   000 ';     number[1, 10] := '    111   ';
  number[0, 11] := '000   000 ';     number[1, 11] := '    111   ';
  number[0, 12] := '000   000 ';     number[1, 12] := '    111   ';
  number[0, 13] := '000000000 ';     number[1, 13] := '  1111111 ';
  number[0, 14] := ' 0000000  ';     number[1, 14] := '  1111111 ';

  number[2, 1]  := ' 2222222  ';     number[3, 1]  := ' 3333333  ';
  number[2, 2]  := '222222222 ';     number[3, 2]  := '333333333 ';
  number[2, 3]  := '222   222 ';     number[3, 3]  := '333   333 ';
  number[2, 4]  := '      222 ';     number[3, 4]  := '      333 ';
  number[2, 5]  := '      222 ';     number[3, 5]  := '      333 ';
  number[2, 6]  := '     222  ';     number[3, 6]  := '     333  ';
  number[2, 7]  := '    222   ';     number[3, 7]  := '  33333   ';
  number[2, 8]  := '   222    ';     number[3, 8]  := '  33333   ';
  number[2, 9]  := '  222     ';     number[3, 9]  := '     333  ';
  number[2, 10] := ' 222      ';     number[3, 10] := '      333 ';
  number[2, 11] := '222       ';     number[3, 11] := '      333 ';
  number[2, 12] := '222       ';     number[3, 12] := '333   333 ';
  number[2, 13] := '222222222 ';     number[3, 13] := '333333333 ';
  number[2, 14] := '222222222 ';     number[3, 14] := ' 3333333  ';

  number[4, 1]  := '      444 ';     number[5, 1]  := '555555555 ';
  number[4, 2]  := '     444  ';     number[5, 2]  := '555555555 ';
  number[4, 3]  := '    444   ';     number[5, 3]  := '555       ';
  number[4, 4]  := '   444    ';     number[5, 4]  := '555       ';
  number[4, 5]  := '  444     ';     number[5, 5]  := '555       ';
  number[4, 6]  := ' 444   444';     number[5, 6]  := '555       ';
  number[4, 7]  := '444    444';     number[5, 7]  := '55555555  ';
  number[4, 8]  := '4444444444';     number[5, 8]  := '555555555 ';
  number[4, 9]  := '4444444444';     number[5, 9]  := '      555 ';
  number[4, 10] := '       444';     number[5, 10] := '      555 ';
  number[4, 11] := '       444';     number[5, 11] := '      555 ';
  number[4, 12] := '       444';     number[5, 12] := '555   555 ';
  number[4, 13] := '       444';     number[5, 13] := '555555555 ';
  number[4, 14] := '       444';     number[5, 14] := ' 5555555  ';

  number[6, 1]  := ' 6666666  ';     number[7, 1]  := '7777777777';
  number[6, 2]  := '666666666 ';     number[7, 2]  := '7777777777';
  number[6, 3]  := '666   666 ';     number[7, 3]  := '       777';
  number[6, 4]  := '666       ';     number[7, 4]  := '       777';
  number[6, 5]  := '666       ';     number[7, 5]  := '      777 ';
  number[6, 6]  := '666       ';     number[7, 6]  := '     777  ';
  number[6, 7]  := '66666666  ';     number[7, 7]  := '    777   ';
  number[6, 8]  := '666666666 ';     number[7, 8]  := '   777    ';
  number[6, 9]  := '666   666 ';     number[7, 9]  := '  777     ';
  number[6, 10] := '666   666 ';     number[7, 10] := ' 777      ';
  number[6, 11] := '666   666 ';     number[7, 11] := '777       ';
  number[6, 12] := '666   666 ';     number[7, 12] := '777       ';
  number[6, 13] := '666666666 ';     number[7, 13] := '777       ';
  number[6, 14] := ' 6666666  ';     number[7, 14] := '777       ';

  number[8, 1]  := ' 8888888  ';     number[9, 1]  := ' 9999999  ';
  number[8, 2]  := '888888888 ';     number[9, 2]  := '999999999 ';
  number[8, 3]  := '888   888 ';     number[9, 3]  := '999   999 ';
  number[8, 4]  := '888   888 ';     number[9, 4]  := '999   999 ';
  number[8, 5]  := '888888888 ';     number[9, 5]  := '999   999 ';
  number[8, 6]  := ' 8888888  ';     number[9, 6]  := '999   999 ';
  number[8, 7]  := '  88888   ';     number[9, 7]  := '999999999 ';
  number[8, 8]  := ' 8888888  ';     number[9, 8]  := ' 99999999 ';
  number[8, 9]  := '888888888 ';     number[9, 9]  := '      999 ';
  number[8, 10] := '888   888 ';     number[9, 10] := '      999 ';
  number[8, 11] := '888   888 ';     number[9, 11] := '      999 ';
  number[8, 12] := '888   888 ';     number[9, 12] := '999   999 ';
  number[8, 13] := '888888888 ';     number[9, 13] := '999999999 ';
  number[8, 14] := ' 8888888  ';     number[9, 14] := ' 9999999  ';

end.

{ ============================= END OF "DRAW.PAS" ========================= }
