;WAKEUP.COM
Comment ~
Date: 09-20-86 (15:48)              Number: 98
  To: ALL                           Refer#: NONE
From: KEITH GRAHAM                  Recv'd: (N/A)
Subj: WAKEUP                        Sec'ty: PUBLIC MESSAGE

I wrote a program for you guys called wakeup.com. It will enter at the
keyboard any string of letters, function keys, etc at any given time.
It grabs the timer and kbd interrupts and at a preset time will fake
the machine into thinking a string is being entered at the keyboard.
It can be a little dangerous, for instance, do not set it up to enter
"/QY" when your boss is going to do his spreadsheets on 123, it would
loose everything for him.
Give it a try and let me know if it works.
                     Keith

Toad Hall Notes:

Bug : Doesn't work the next day (like 24 hours after the first Wakeup).
Also, if installed, breaks the clock rollover at midnight!

No source, so had to disassemble with DASM31 and ASMGEN.  Sigh ...
damned people who won't release or distribute source ...

Allen Mitchell, SEMPER BBS, needs it fixed.

Fixed 31 Oct 87.  Extensive hack, tweaking.  
Still a kludge.  Needs much work, including incorporating some of the goodies
from REMIND.ASM:
	Reset alarm time
	Reset command string
	Command line entry option
	Check if already resident (not load on top of resident one)
	Use FCB (0..100H) instead of data in code space
	Get off Int 8 and onto 1C just to be polite.
	Clean up time parsing code (ugh)

Releasing source and executable as TOADWAKE.  Sorry, Keith, but it
was broke!

~

	PAGE	,132
;Toad Hall Patch
CR	equ	0DH
LF	equ	0AH

RET_FAR_POP	MACRO	X
db	0CAH
dw	X
ENDM
;

;Toad Hall Patch
PageZero	SEGMENT at	0
	org	046CH
timerlo		dw	?
timerhi		dw	?
rollover	db	?
PageZero	ENDS

CodeSeg	SEGMENT BYTE PUBLIC 'code'
	ASSUME	CS:CodeSeg
	ASSUME	SS:CodeSeg
	ASSUME	DS:CodeSeg

	org	100H

WakeUp	PROC	FAR
	ASSUME	ES:CodeSeg
H00100:
	jmp	Begin

BeepFlag	db	0	;flag if we're working the buffer
rint8		dd	0	;old Int 08H vector
rint16		dd	0	;old Int 16H vector
msglo		dw	0000H
msghi		dw	0000H
ticker		db	0
seqlen		dw	?	;original buffer length
SeqBuff		dw	0000H	;buffer with our sequence chars
		db	404 DUP(?)
seqctr		dw	0000H	;counter how many chars remain?
seqbuffptr	dw	0	;pointer to current psn in key sequence buffer

NewInt16:
	sti
	cmp	CS:BeepFlag,0		;beeped yet?
	jne	Skp2B9			; yep, go to work
GotoOld16:
	jmp	dword ptr CS:rint16

Skp2B9:	cmp	ah,1			;Int 16H report whether char ready?
	ja	GotoOld16		;another svc req, not for us, exit
	push	dx			;TH
	push	bx
	mov	bx,CS
	mov	DS,bx
	ASSUME	DS:CodeSeg

	mov	bx,seqbuffptr		;current sequence buffer offset
	cmp	ah,1			;really req if kbd char ready?
	je	Skp2D5			;yep, go process it
;must be service 0, read next kbd char
	add	seqbuffptr,2		;just reading the key sequence
	dec	seqctr			;adjust key sequence counter
Skp2D5:	mov	bx,[bx+SeqBuff]		;save the key values in bx for now
	xor	ax,ax			;get a handy zero
	cmp	seqctr,ax		;sent all key values?
	jne	ReturnKey		; nope, not yet

;all done, reinitialize stuff so we'll work again 24 hours from now.
	mov	BeepFlag,al		;sent, turn off flag
	mov	ax,seqlen		;get original sequence length
	mov	seqctr,ax		;refresh sequence key counter
	mov	ax,offset SeqBuff	;start of key buffer
	mov	seqbuffptr,ax		;point our pointer back at start

;sets ZF to ready (on, NZ)
ReturnKey:
	xor	ax,ax			;set our zero flag
	cmp	al,1			;this way
	mov	ax,bx			;return the key val in ax
	pop	bx			;restore orig reg
	pop	DS
	clc				;insure carry clear
	RET_FAR_POP	2

NewInt8:
	pushf				;save calling procedure's flags
	call	DWORD PTR CS:rint8	;call old Int 8
	sti				;restore ints
;just check every 12 ticks (not quite a second}
	inc	CS:ticker
	cmp	CS:ticker,12		;12 ticks yet?
	jb	DoIret			; nope, just iret
	cmp	CS:BeepFlag,1		;beeped yet?
	je	DoIret			; yep, just iret

	push	DS			;save our reggies
	push	ax
	xor	ax,ax
	mov	CS:ticker,al		;reset our 12-tick counter
	mov	DS,ax			;point to page 0
	ASSUME	DS:PageZero

	mov	ax,timerhi		;DOS hi time val
	cmp	ax,CS:msghi
	jne	Iret334			;not time yet
	mov	ax,timerlo
	and	ax,0FFF0H		;mask the low portion
	cmp	ax,CS:msglo
	je	BeepIret		;it's time, beep and iret
	
Iret334:
	pop	ax			;restore reggies
	pop	DS
DoIret:
	iret

BeepIret:
	mov	CS:BeepFlag,1		;flag we woke him up?
	mov	ax,0E07H		;write bell as TTY
	int	10H			;BIOS
	jmp	SHORT Iret334		;and pop/return from interrupt
;end of resident interrupt functions

;loading functions
	ASSUME	DS:CodeSeg		;keep MASM happy

Begin:
	mov	dx,offset IntroM	;Introduction msg
	mov	ah,09H
	int	21H
	mov	ah,30H			;get current DOS version
	int	21H
	cmp	al,02H			;DOS 2.0 or more?
	jae	GetUserTime		; yep, fine
	mov 	dx,offset BadDosM	;"Wrong Dos..."
	mov	ah,09H
	int	21H
	int	20H			;terminate

BadTime:
	mov	dx,offset BadTimM	;"Wrong, must be 6 chars..."
	mov	ah,09H
	int	21H

;Prompt user for time, read his entry.
GetUserTime:
	mov	dx,offset EnterTmM	;"Enter time as ...."
	mov	ah,09H
	int	21H
	mov	dx,offset timebuff	;time string buffer
	mov	ah,0AH			;buffered kbd input
	int	21H
	cmp	H00782,06H		;got 6 chars?
	jne	BadTime			; nope, gotta be bad
	mov	cx,0006H		;6 chars
	mov	SI,offset hour		;start at hour in time string
	cld				;insure fwd

;First, make sure all time string chars are legal number characters.
ChkTimCharLup:
	lodsb
	cmp	al,'0'			;less than a number char?
	jb	BadTime			; yep, gotta be bad
	cmp	al,'9'			;greater than '9'?
	ja	BadTime			; yep, gotta be bad
	loop	ChkTimCharLup

	mov	cx,0003H		;3 words counter
	mov	SI,offset hour		;check out our time string
	mov	DI,SI			;to here also
	cld				;insure fwd
TimeConvLup:
	push	cx			;save time word counter
	lodsw				;snarf first 2 time digits
	and	ax,0F0FH		;mask
	mov	bl,ah
	mov	ah,00H			;clear msb
	mov	cl,0AH			;multiplier of 10
	mul	cl			;digit * 10
	add	al,bl			;add in lsb
	stosw				;stuff back as integer
	pop	cx			;time digit counter
	loop	TimeConvLup		;do all digits
	mov	ax,second		;snarf seconds
	cmp	al,60			;seconds legal?
	jb	Skp3B9			; yep
	jmp	BadTime			; bad

Skp3B9:
	mov	bx,ax
	mov	ax,minute		;check out minutes
	cmp	al,60			;minutes legal?
	jb	Skp3C4			; ok, <60
	jmp	BadTime			; bad

Skp3C4:
	mov	cl,60
	mul	cl			;minutes * 60
	add	bx,ax			;accumulate in bx
	mov	ax,hour			;check out hour
	cmp	al,24			;< 24 hrs?
	jb	Skp3D3			; yep, <24 hrs
	jmp	BadTime			; bad

;Convert decimal time to DOS-compatible 2-word value
Skp3D3:
	mov	cx,0E10H
	xor	dx,dx
	mul	cx
	add	ax,bx
	jnc	Skp3E0
	inc	dx
Skp3E0:
	mov	bx,dx
	mov	SI,ax
	xor	ax,ax
	mov	msghi,ax
	mov	msglo,ax
	mov	dx,ax			;clear remainder
	mov	ax,bx
	mov	cx,0012H		;*18
	mul	cx
	mov	msghi,ax		;our hi alarm time
	mov	ax,bx
	xor	dx,dx
	mov	cx,0D37H		;*?
	mul	cx
	mov	cx,4000H
	div	cx
	add	msghi,ax		;add in our hi alarm time
	mov	ax,dx			;and the remainder
	xor	dx,dx
	mov	cx,0004H		;*4
	mul	cx
	mov	msglo,ax		;our lo alarm time
	mov	ax,SI
	xor	dx,dx
	mov	cx,0012H		;*18
	mul	cx
	add	msghi,dx		;add in our hi alarm time
	add	msglo,ax		;and lo alarm time
	jnc	Skp435			;no adjustment needed
	inc	msghi			;adjust
Skp435:
	mov	ax,SI
	xor	dx,dx
	mov	cx,0D37H		;*?
	mul	cx
	mov	cx,4000H
	div	cx
	add	msglo,ax		;still figuring low time
	jnc	Skp44E			;no adjustment needed
	inc	msghi			;adjust hi time
Skp44E:
	and	msglo,0FFF0H		;mask
ChekTimeLup:
	mov	dx,offset RitTimM	;"Is the time correct?"
	mov	ah,09H
	int	21H
	mov	dx,offset KbdBuf78B	;get user input
	mov	ah,0AH
	int	21H
	cmp	KbdBuf78D,'Y'		;yep, time is ok
	je	KeyStrkLup		;go get Key Sequence
	cmp	KbdBuf78D,'y'
	je	KeyStrkLup
	cmp	KbdBuf78D,'N'
	je	JmpBadTime		;wrong time, go fix it
	cmp	KbdBuf78D,'n'
	je	JmpBadTime
	mov	dx,offset CrLfM		;Display CR/LF
	mov	ah,09H
	int	21H
	jmp	ChekTimeLup		;wrong answer, go ask again

JmpBadTime:
	jmp	BadTime			;time was bad

KeyStrkLup:
	mov	dx,offset EntrKsM	;"Enter keystrokes ..."
	mov	ah,09H
	int	21H
	mov	plusctr,00H
	mov	seqctr,0000H
	mov	DI,offset SeqBuff	;Start of key sequence buffer
	mov	cx,00C8H		;max chars in Sequence?
Lup4A8:
	push	cx
	mov	ah,00H			;read next kbd char
	int	16H			;BIOS
	cmp	ax,4E2BH		;ah=scan code, al=char code
	jne	NotPlus			;wasn't keypad + char
	inc	plusctr			;bump the + counter
	cmp	plusctr,03H		;did all 3?
	je	KbdDone			; yep, done with keyboard input
	jmp	SHORT AddtoSeq		; nope, add to buffer

NotPlus:
	mov	plusctr,00H		;clear counter
AddtoSeq:
	inc	seqctr
	stosw				;stuff word & scan in Seq Buff
	mov	ah,0EH			;prep to write char as TTY
	cmp	al,CR			;user CR?
	jne	Skp4D7			; nope
	int	10H			; yep, display it
	mov	ax,0E0AH		;and the LF
Skp4D7:
	int	10H			;BIOS write char as TTY
	loop	Lup4A8			;do next
	add	seqctr,02H		;bump counter by 2
KbdDone:
	sub	seqctr,02H		;adjust for last 2 that don't count
QuerySeqLup:
	mov	dx,offset RitSeqM	;"Is the sequence correct ...?"
	mov	ah,09H			;print str
	int	21H
	mov	dx,offset KbdBuf78B	;input buffer
	mov	ah,0AH			;Buffered kbd input
	int	21H
	cmp	KbdBuf78D,'Y'		;Yes?
	je	SetNewVecs		; yep, correct sequence
	cmp	KbdBuf78D,'y'		;yes?
	je	SetNewVecs		; go set new vectors & terminate
	cmp	KbdBuf78D,'N'		;No?
	je	KeyRelup		; nope,incorrect sequence
	cmp	KbdBuf78D,'n'		;no?
	je	KeyRelup		; .. so go do it again
	cmp	KbdBuf78D,'A'		;Abort?
	je	Quit			; yep, abort
	cmp	KbdBuf78D,'a'		;abort?
	je	Quit
	mov	dx,offset CrLfM		;new line
	mov	ah,09H			;must be something else
	int	21H
	jmp	short QuerySeqLup

Quit:
	mov	dx,offset CrLfM		;write CR/LF
	mov	ah,09H
	int	21H
	int	20H

KeyRelup:
	jmp	KeyStrkLup

;Set our new interrupt vectors for Int 08H and Int 16H
SetNewVecs:
	mov	ax,seqctr
	mov	seqlen,ax		;save original length
	mov	ax,3508H		;get Int 8H vector
	int	21H			;returned in ES:bx
	mov	word ptr rint8+2,ES	;save it
	mov	word ptr rint8,bx
	mov	ax,2508H		;set new Int 8H vector
	mov	dx,offset NewInt8	;point to our new process
	int	21H
	mov	ax,3516H		;Get Int 16H vector
	int	21H			;returned in ES:bx
	mov	word ptr rint16+2,ES	;save it
	mov	word ptr rint16,bx
	mov	ax,2516H		;Set Int 16H vector
	mov	dx,offset NewInt16	;our process
	int	21H

	mov	dx,offset Begin		;memory to free (start)
	add	dx,0FH			;change to paras/segment
	mov	cl,04H
	shr	dx,cl
	mov	ax,3100H		;Terminate & stay res
	int	21H
	int	20H			;terminate (dumb)
WakeUp	ENDP

;H00575
IntroM	LABEL	WORD
	db	'WAKEUP Resident Wakeup call',CR,LF
	db	'Written by Keith P. Graham 9/19/86',CR,LF
	db	'For the users of PC Rockland BBS (914) 353-2176'
	db	CR,LF,'(with an extensive Toad Hall hack, 871031)'
CrLfM	db	CR,LF,'$'
EnterTmM db	CR,LF,'Enter time for wakeup as HHMMSS (military time) :$'
BadTimM	db	CR,LF,'Time must be six numeric digits, try again',CR,LF,'$'
BadDosM	LABEL	WORD
	db	'Wrong DOS version, Must be 2.0 or later',CR,LF
RitTimM	db	CR,LF
	db	'Is the time correct? (y/n): $'
EntrKsM	db	CR,LF,'Enter Keystrokes to be entered at the specified time.'
	db	CR,LF,'You have up to 200 characters you can enter.'
	db	CR,LF,'When you are done, press the + on the numeric keypad'
	db	CR,LF,'three times.'
	db	CR,LF,LF
	db	'   ENTER:'
	db	CR,LF,'$'
RitSeqM	db	CR,LF,'Is the sequence correct (Y)es, (N)o, (A)bort :$'
plusctr	db	0
timebuff db	7
H00782	db	0
hour	dw	2020H
minute	dw	2020H
second	LABEL	WORD
	db	'  '
	db	'  '
KbdBuf78B	dw	0002H
KbdBuf78D	db	20H,20H
CodeSeg	ENDS
	END	WakeUp
